3 algorithms:


% I expect this one to be more efficient in multicore cpus
\subsection{Algo 1}
\begin{itemize}
  \item[Input] an adjacency matrix: (same formal definition as above).
  \item[Output] a cooccurence matrix.
\end{itemize}

\paragraph{Main idea}
\begin{enumerate}
  \item Slice the adjacency vertically in $x$ parts. Slice $1$ contains $a_{i,j}$ with $i \in [1,n/x]$ and $j \in [1,n]$, slice $2$ contains $l_i$ with $i \in [n/x + 1, 2n/x]$ and $j \in [1,n]$, ..., slice $x$ contains $l_i$ with $i \in [n-n/x + 1, n]$ and $j \in [1,n]$.
  \item For each slice, compute in parallel the partial cooccurence matrix [see algo 1 or 2 from Master Thesis De-Joy Amankwah].
  \item Finally sum all the partial cooccurence cooccurence.
\end{enumerate}

Figure \ref{sch-algo-1} give a schematic illustration of the algorithm.

\begin{figure}
  %\includegraphics{/path/to/figure}
  \caption{Schematic representation of Algo 1}
  \label{sch-algo-1}
\end{figure}

\paragraph{How many I/O?}
One read of the adjacency matrix for the slicing, $x$ writes in memory for each slice, $x$ reads (one for each partial cooccurence matrix) plus finally one write for the complete cooccurence list.

\paragraph{Complexity}
Complexity of the algo to compute the partial cooccurence matrix.
Complexity of the summation of partial cooccurence lists into the complete one.

\paragraph{How much memory}
Each partial cooccurence matrix requires $n^2$ bits, the same for the adjacency matrix, the same for the complete cooccurence matrix.

[Maybe we can use streaming approach (only use two vectors of size $n$) to reduce the memory usage. Cost I/O therefore time]

\paragraph{Implementation}
\subsection{Algo 2}
\begin{itemize}
  \item[Input] an adjacency matrix: (same formal definition as above).
  \item[Output] a cooccurence matrix.
\end{itemize}

\paragraph{Main idea}

Using symmetry: $coocc(i,j) = coocc(j,i)$, therefore for each node $i$ it is only required to compute cooccurence between $i$ and the nodes $j > i$ [index notation better?].

\begin{enumerate}
  \item For each node $i$ (fixed), get rows $j \geq i$. $a_{j,k}$ with $j \geq i$. To compute $coocc(n-1,n)$ one needs two vectors of size $n$, to compute $coocc(n-2,j)$ with $j \in [n-1,n]$ one needs 3 vectors of size $n$, ..., to compute $coocc(1,j)$ with $j \in [2,n]$ one needs $n$ vectors of size $n$,
  \item For each node $i$, compute its cooccurrence $coocc(i,j)$ with $j > i$.
  \item Finally merge all the cooccurence in one matrix (if needed, just read the results).
\end{enumerate}

Figure \ref{sch-algo-2} give a schematic illustration of the algorithm.

\begin{figure}
  %\includegraphics{/path/to/figure}
  \caption{Schematic representation of Algo 2}
  \label{sch-algo-2}
\end{figure}

\paragraph{How many I/O?}
$n-1$ reads of the adjacency matrix, $n-1$ writes in memory for each node, $n-1$ reads (one for each line of the upper symmetric part of the cooccurence matrix) plus finally one (optional) write for the complete cooccurence matrix.

\paragraph{Complexity}

\paragraph{How much memory}

\paragraph{Optimisation}
Group the computations of $coocc(i,j)$ together by memory requirement and number of cumputation needed (start from $i = n-1$ and decrease it).

[schema]

\paragraph{Implementation}
\subsection{Algo 3}
\begin{itemize}
  \item[Input] an adjacency list: (same formal definition as above).
  \item[Output] a cooccurence list.
\end{itemize}

\paragraph{Main idea}
\begin{enumerate}
  \item Slice the list in $x$ parts (for now of equal number of rows). Slice $1$ contains $l_i$ with $i \in [1,n/x]$, slice $2$ contains $l_i$ with $i \in [n/x + 1, 2n/x]$, ..., slice $x$ contains $l_i$ with $i \in [n-n/x + 1, n]$.
  \item For each slice, compute in parallel the partial cooccurence list [see algo 4 from Master Thesis De-Joy Amankwah].
  \item Finally sum all the partial cooccurence lists.
\end{enumerate}

Figure \ref{sch-algo-3} give a schematic illustration of the algorithm.

\begin{figure}
  %\includegraphics{/path/to/figure}
  \caption{Schematic representation of Algo 3}
  \label{sch-algo-3}
\end{figure}

\paragraph{How many I/O?}
One read of the adjacency list for the slicing, $x$ writes in memory for each slice, $x$ reads (one for each partial cooccurence list) plus finally one write for the complete cooccurence list.

\paragraph{Complexity}
Complexity of the algo to compute the partial cooccurence lists.
Complexity of the summation of partial cooccurence lists into the complete one.

\paragraph{How much memory}
This cannot be done in $\bigO(1)$, since one needs to save intermediate values for the neighbors of $i$ at worst it is $\bigO(n^2)$ when the graph is all-to-all connected (in that extreme case this algorithm do not bring anything). [better theoretical approximation?]

\paragraph{Implementation}
